import 'package:html/parser.dart' show parse;
import 'dart:io';


Map<dynamic,dynamic> parseSchedule(String body) {
  Map<dynamic, dynamic> schedule = new Map();
  schedule['course'] = new List();
  String content;
  if (body == null) {

  } else {
    content = body;
  }
  var document = parse(content);
  List data = document.querySelectorAll('div.scheduleItem');
  data.forEach((item) {
    if(item.text.toString().contains('Total')) {
      RegExp exp = new RegExp(r"(\d{1,2}\.\d)");/// match for foramt like 13.0
      if (item.text.toString().contains('Waitlist')){
        schedule['waitlistUnits'] = double.parse(exp.firstMatch(item.text).group(0));/// waitlist unit
      }
      else{
        schedule['units'] = double.parse(exp.firstMatch(item.text).group(0)); /// registered unit
      }
    }

    else if( RegExp(r"((\d{1,2}:\d{1,2}(PM|AM)))").allMatches(item.text.toString().split(' ').join().split('\n').join()).length==4){
      //match the course with section
    List<String> info = item.text.toString().split('  ').join('').split('\n');
        info.removeWhere((item) => item == '');
    schedule['course'].add(new Course(
          info[0],
          info[6].toString().replaceFirst('Location', '').trim(),
          info[4].toString().replaceFirst('Days', '').trim(),
          info[5].toString().replaceFirst('Time', '').split('-')[0],
          info[5].toString().replaceFirst('Time', '').split('-')[1],
          double.parse(info[3].toString().split('Unit')[0].trim()),
          int.parse(info[1].toString().trim()),
          info[2].toString().split(':')[1].trim(),
          info[7].toString().replaceFirst('Instructor', '').trim(),
          ta: info[11].toString().replaceFirst('Instructor', '').trim(),
          sectionBeginTime:
              info[9].toString().replaceFirst('Time', '').split('-')[0],
          sectionEndTime:
              info[9].toString().replaceFirst('Time', '').split('-')[1],
          sectionDate: info[8].toString().replaceFirst('Days', '').trim(),
          sectionLocation:
              info[10].toString().replaceFirst('Location', '').trim()));

    }
    else if(item.text.toString().contains('View')){
      //courses in the waiting list
    }
    else{
      print(RegExp(r"((\d{1,2}:\d{1,2}(PM|AM)){4})").allMatches(item.text.toString().split(' ').join().split('\n').join()).length);
      ///add course withtout section
        List<String> info = item.text.toString().split('  ').join('').split('\n');
    info.removeWhere((item) => item == '');
    schedule['course'].add(new Course(
          info[0],
          info[6].toString().replaceFirst('Location', '').trim(),
          info[4].toString().replaceFirst('Days', '').trim(),
          info[5].toString().replaceFirst('Time', '').split('-')[0],
          info[5].toString().replaceFirst('Time', '').split('-')[1],
          double.parse(info[3].toString().split('Unit')[0].trim()),
          int.parse(info[1].toString().trim()),
          info[2].toString().split(':')[1].trim(),
          info[7].toString().replaceFirst('Instructor', '').trim(),
          ));
    }

    print(schedule['course'].toString());
  });
  return schedule;
}

///@deprecated
getClassTitle({String body}) async {
  List<String> classTitle = new List();
  String content;
  if (body == null) {
  } else {
    content = body;
  }
  var document = parse(content);
  List sourceClassTitle = document.querySelectorAll('p.courseTitle > span');
  sourceClassTitle.forEach((element) {
    classTitle.add(element.text
        .trim()
        .split('   ')
        .join(' ')
        .split('  ')
        .join(' ')
        .split('  ')
        .join(' '));
  });
  print(classTitle);
  return classTitle;
//     document.querySelectorAll('p.courseTitle > span')[0].outerText
// "ARTHI 6B - SURVEY II: REN-BAR Session A (6/24 - 8/3)"
}


///@deprecated
getClassTime({String body}) async {
  List<String> classTitle = new List();
  String content;
  if (body == null) {
  } else {
    content = body;
  }
  var document = parse(content);
  var sourceClassTime = document.querySelectorAll('selector');
}

class Course {
  String title;
  String lectureLocation;
  String sectionLocation;
  String sectionBeginTime;
  String sectionEndTime;
  String sectionDate;
  String lectureDate;
  String lectureBeginTime;
  String lectureEndTime;
  String professor;
  String ta;
  int id;
  double unit;
  String gradingPolicy;
  Course(
      this.title,
      this.lectureLocation,
      this.lectureDate,
      this.lectureBeginTime,
      this.lectureEndTime,
      this.unit,
      this.id,
      this.gradingPolicy,
      this.professor,
      {this.ta,
      this.sectionDate,
      this.sectionLocation,
      this.sectionBeginTime,
      this.sectionEndTime});
}
