library ucsb_gold;

import 'package:http/http.dart' as http;
import 'package:html/parser.dart' show parse;
import 'package:logger/logger.dart';
import './parse.dart';

class Gold {
  Logger logger = new Logger();
  String _host = "my.sa.ucsb.edu";
  String _protocol = "https";
  String _username;
  String _password;
  Map<String, String> _headers = {
    "Host": "my.sa.ucsb.edu",
    "Connection": "close",
    "Cache-Control": "max-age=0",
    "Origin": "https://my.sa.ucsb.edu",
    "Content-Type": "application/x-www-form-urlencoded",
    "User-Agent":
        "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.172 Safari/537.36 Vivaldi/2.5.1525.48",
    "Accept":
        "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3",
    "Referer": "https://my.sa.ucsb.edu/gold/Login.aspx",
    "Accept-Encoding": "gzip, deflate",
    "Accept-Language": "en-US,en;q=0.9"
  };

  /// store all the cookie
  /// date:expires;
  Map<String, dynamic> _cookie = new Map();

  /// sign in to the gold
  Future<bool> signIn(String username, String password) async {
    // HttpClient client = new HttpClient();
    // client.findProxy = 'PROXY 127.0.0.1:8097';
    _username = username;
    _password = password;
    Map<String, String> parameter = await getSginInParameter();
    Map<String, String> cookie = await getARRAffinity();
    parameter["ctl00\$pageContent\$userNameText"] = username;
    parameter["ctl00\$pageContent\$passwordText"] = password;
    parameter["ctl00\$pageContent\$loginButton"] = "Login";
    // "session_my.sa.ucsb.edu_gold=tjgmwpabgfzdnk1pbwn4zr3f; path=/; HttpOnly,GOLDCookie=GOLDCookie; path=/"
    cookie["session_my.sa.ucsb.edu_gold"] = "tjgmwpabgfzdnk1pbwn4zr3f";
    cookie["GOLDCookie"] = "GOLDCookie";
    var uriResponse = await http.post("$_protocol://$_host/gold/Login.aspx",
        body: {
          ...parameter,
          // ...cookie
        },
        headers: _headers);
    if (uriResponse.statusCode != 302) {
      throw new Exception('Login failed');
    }
    // if there is no set cookie, than the login is fail.
    _cookie['session_my.sa.ucsb.edu_gold'] =
        uriResponse.headers['set-cookie'].split(';')[0].split('=')[1];
    _cookie['auth_my.sa.ucsb.edu_gold'] =
        uriResponse.headers['set-cookie'].split(';')[3].split('=')[2];

    /// _cookie['expires']= DateTime.parse(uriResponse.headers['expires']); //Sat, 10 Aug 2019 07:15:54 GMT
    _cookie['expires'] =
        uriResponse.headers['expires']; //Sat, 10 Aug 2019 07:15:54 GMT
    logger.i(_cookie);
    return true;
    // session_my.sa.ucsb.edu_gold=swnot1xpgqi2iuibcheyhnmz; path=/; HttpOnly,GOLDCookie=GOLDCookie; path=/,auth_my.sa.ucsb.edu_gold=8A6E3FE1792E473616ACBD36B201CC5038CAB7F1F7150B61E9BC3F6DA7D24E6235790315C9794FDF5944EBE9E2734DEB882DC8A305C19AADA49853728F7CE32F3C3E81F93FD25A66BED3BB8A8515F92CADBFCDE80A1A13303ED4930ACF248E6CD608BDA59BAC0DB5E01110097C239A9C8F8D4223C73FB601BA15A401D37E0E86A39500D4; path=/
  }

  // other parameter which is neccessary for login post request
  Future<Map> getSginInParameter() async {
    Map<String, String> parameter = new Map<String, String>();
    http.Response response =
        await http.get("$_protocol://$_host/gold/Login.aspx");
    var document = parse(response.body);
    String viewState =
        document.getElementById("__VIEWSTATE").attributes['value'];
    String viewStateGenerator =
        document.getElementById("__VIEWSTATEGENERATOR").attributes['value'];
    String eventValidation =
        document.getElementById("__EVENTVALIDATION").attributes['value'];
    parameter["__VIEWSTATE"] = viewState;
    parameter["__VIEWSTATEGENERATOR"] = viewStateGenerator;
    parameter["__EVENTVALIDATION"] = eventValidation;
    return parameter;
  }

  ///Get one of the cookie
  Future<Map<String, String>> getARRAffinity() async {
    http.Response response =
        await http.get("$_protocol://$_host/Bulletins/api/goldlogin/active");

    /// To get the cookie value from the heaers
    ///
    ///  "ARRAffinity_my.sa.ucsb.edu_bulletins=808a8a15a4d8ae50e1724b76589ebdbad90cf5166124de5fa0c1c500e95f66fe;Path=/;"
    String cookie = response.headers['set-cookie'];
    cookie = cookie.split(';')[0].split('=')[1];
    return {'ARRAffinity_my.sa.ucsb.edu_bulletins': cookie};
  }
  /// only support for get current schedule now
  Future<Map> getSchedule() async {
    bool tryAgain = false;
    Map schedule;
    while (tryAgain) {
      try {
        tryAgain = false;
        var uriResponse = await http.post(
            "$_protocol://$_host/gold/StudentSchedule.aspx",
            body: {},
            headers: {
              ..._headers,
              "cookie": "session_my.sa.ucsb.edu_gold=" +
                  _cookie['session_my.sa.ucsb.edu_gold']
            });
        if (uriResponse.statusCode == 302) {
          throw new Exception('wrong cookie');
        }
        schedule = parseSchedule( uriResponse.body);
      } catch (e) {
        tryAgain = true;
        await signIn(_username, _password);
      }
    }
    return schedule;
  }
}
