import 'package:flutter_test/flutter_test.dart';
import 'dart:io';
import 'package:ucsb_gold/ucsb_gold.dart';
import '../lib/parse.dart';

void main() {
  Map<String, String> env = Platform.environment;
  test('getARRAffinity', () async {
    final gold = Gold();
    var response = await gold.getARRAffinity();
    expect(response['Path'], null);
    expect(response['ARRAffinity_my.sa.ucsb.edu_bulletins'].length, 64);
  });


  test('get parameter for login post request', () async {
    final gold = Gold();
    var response = await gold.getSginInParameter();
    expect(response['__VIEWSTATEGENERATOR'].length, "00732C32".length);
    expect(response['__VIEWSTATE'].contains('/w'), true);
    expect(response['__EVENTVALIDATION'].contains('/w'), true);
  });

  test('sign in', () async {
    final gold = Gold();
    bool response = await gold.signIn(env['goldUsername'], env['goldPassword']);
    expect(response, true);
    // expect(response.length, "8A6E3FE1792E473616ACBD36B201CC5038CAB7F1F7150B61E9BC3F6DA7D24E6235790315C9794FDF5944EBE9E2734DEB882DC8A305C19AADA49853728F7CE32F3C3E81F93FD25A66BED3BB8A8515F92CADBFCDE80A1A13303ED4930ACF248E6CD608BDA59BAC0DB5E01110097C239A9C8F8D4223C73FB601BA15A401D37E0E86A39500D4".length);
  });
  test('sign in with wrong account', () async {
    try {
      final gold = Gold();
      await gold.signIn('sd', 'sdf');
    } catch (e) {
      expect(e.message, 'Login failed');
    }
    // expect(response.length, "8A6E3FE1792E473616ACBD36B201CC5038CAB7F1F7150B61E9BC3F6DA7D24E6235790315C9794FDF5944EBE9E2734DEB882DC8A305C19AADA49853728F7CE32F3C3E81F93FD25A66BED3BB8A8515F92CADBFCDE80A1A13303ED4930ACF248E6CD608BDA59BAC0DB5E01110097C239A9C8F8D4223C73FB601BA15A401D37E0E86A39500D4".length);
  });
  test('get schedule', () async {
    final gold = Gold();
    await gold.signIn(env['goldUsername'], env['goldPassword']);
    Map schedule = await gold.getSchedule();
    // expect(schedule['course'],isNotNull );
    // expect(schedule['units'], isNotNull);
    // expect(schedule['waitlistUnits'],isNotNull);
    assert(schedule['units'] is double);
    assert(schedule['waitlistUnits'] is double);
    assert(schedule['course'] is List);
    expect(schedule['course'][0], isNotNull);
    // assert(schedule['course'][0] is );


  });
}
